import collections
from classes.Sentence import *
from classes.Paragraph import *
from functions import test_constraint

class Document_Collection:
  def __init__(self, _id, paragraphsraw, signalwords, sequencemarkers, stopwords, nlp, only_constraints):
    self._id = _id
    self.paragraphsraw = paragraphsraw
    self.signalwords = signalwords
    self.sequencemarkers = sequencemarkers
    self.stopwords = stopwords
    self.nlp = nlp
    self.only_constraints = only_constraints
    self.constraints = list()
    self.paragraphs = self.get_paragraphs()


### calculate paragraphs and build sentences and clauses
  def get_paragraphs(self):
    paras = list()
  
    for paraid, para in self.paragraphsraw.items():
      result = list()
      doc = self.nlp(para)
      doc.user_data["id"] = paraid 
        
      sentences = doc.sents  
    
      for idx, sentence in enumerate(sentences):    
        flag = test_constraint(sentence, self.signalwords)
        sentence_object = Sentence(doc.user_data["id"], doc.user_data["id"]+str(idx), self.nlp, self.stopwords, flag, sentence)
        result.append(sentence_object)
        if(flag):
          self.constraints.append(sentence_object)
      paras.append(Paragraph(doc.user_data["id"], result, self.sequencemarkers, self.only_constraints))
    
    return paras

